
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class MembershipsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const memberships = await db.memberships.create(
            {
                id: data.id || undefined,
        
        role: data.role
        ||
        null
            ,
            
        membership_status: data.membership_status
        ||
        null
            ,
            
        joined_at: data.joined_at
        ||
        null
            ,
            
        invited_at: data.invited_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await memberships.setUser( data.user || null, {
            transaction,
        });
        
        await memberships.setTeam( data.team || null, {
            transaction,
        });
        
        await memberships.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return memberships;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const membershipsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                role: item.role
            ||
            null
            ,
            
                membership_status: item.membership_status
            ||
            null
            ,
            
                joined_at: item.joined_at
            ||
            null
            ,
            
                invited_at: item.invited_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const memberships = await db.memberships.bulkCreate(membershipsData, { transaction });

        // For each item created, replace relation files
        

        return memberships;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const memberships = await db.memberships.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.role !== undefined) updatePayload.role = data.role;
        
        
        if (data.membership_status !== undefined) updatePayload.membership_status = data.membership_status;
        
        
        if (data.joined_at !== undefined) updatePayload.joined_at = data.joined_at;
        
        
        if (data.invited_at !== undefined) updatePayload.invited_at = data.invited_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await memberships.update(updatePayload, {transaction});

        
        
        if (data.user !== undefined) {
            await memberships.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        
        if (data.team !== undefined) {
            await memberships.setTeam(
              
              data.team,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await memberships.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return memberships;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const memberships = await db.memberships.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of memberships) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of memberships) {
                await record.destroy({transaction});
            }
        });


        return memberships;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const memberships = await db.memberships.findByPk(id, options);

        await memberships.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await memberships.destroy({
            transaction
        });

        return memberships;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const memberships = await db.memberships.findOne(
            { where },
            { transaction },
        );

        if (!memberships) {
            return memberships;
        }

        const output = memberships.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.user = await memberships.getUser({
            transaction
        });
        
        
        output.team = await memberships.getTeam({
            transaction
        });
        
        
        output.organizations = await memberships.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.teams,
        as: 'team',
        
        where: filter.team ? {
          [Op.or]: [
            { id: { [Op.in]: filter.team.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.team.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            

            
            

            
            if (filter.joined_atRange) {
                const [start, end] = filter.joined_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    joined_at: {
                    ...where.joined_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    joined_at: {
                    ...where.joined_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.invited_atRange) {
                const [start, end] = filter.invited_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    invited_at: {
                    ...where.invited_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    invited_at: {
                    ...where.invited_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.role) {
                where = {
                    ...where,
                role: filter.role,
            };
            }
            
            if (filter.membership_status) {
                where = {
                    ...where,
                membership_status: filter.membership_status,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.memberships.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'memberships',
                        'role',
                        query,
                    ),
                ],
            };
        }

        const records = await db.memberships.findAll({
            attributes: [ 'id', 'role' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['role', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.role,
        }));
    }

    
};

